Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3931)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3956)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Removed salsa calls.
+! 
+! 3931 2019-04-24 16:34:28Z schwenkel
 ! Correct/complete module_interface introduction for chemistry model
 ! 
@@ -464,10 +467,4 @@
 #endif
 
-    USE salsa_mod,                                                             &
-        ONLY:  aerosol_mass, aerosol_number, dt_salsa, last_salsa_time,        &
-               nbins_aerosol, ncomponents_mass, ngases_salsa,                  &
-               salsa_boundary_conds, salsa_diagnostics, salsa_driver,          &
-               salsa_gas, salsa_gases_from_chem, skip_time_do_salsa
-
     USE statistics,                                                            &
         ONLY:  hom
@@ -518,8 +515,4 @@
     INTEGER(iwp) ::  i                   !<
     INTEGER(iwp) ::  i_omp_start         !<
-    INTEGER(iwp) ::  ib                  !< index for aerosol size bins (salsa)
-    INTEGER(iwp) ::  ic                  !< index for chemical compounds (salsa)
-    INTEGER(iwp) ::  icc                 !< additional index for chemical compounds (salsa)
-    INTEGER(iwp) ::  ig                  !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  j                   !<
     INTEGER(iwp) ::  k                   !<
@@ -550,64 +543,7 @@
 !
 !-- Module Inferface for exchange horiz after non_advective_processes but before
-!-- advection. Therefore, non_advective_processes must not run for ghost points. 
+!-- advection. Therefore, non_advective_processes must not run for ghost points.
+    !$OMP END PARALLEL
     CALL module_interface_exchange_horiz()
-    !$OMP END PARALLEL
-
-!
-!-- Run SALSA and aerosol dynamic processes. SALSA is run with a longer time 
-!-- step. The exchange of ghost points is required after this update of the 
-!-- concentrations of aerosol number and mass 
-    IF ( salsa )  THEN
-
-       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
-          IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
-          THEN
-             CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
-             !$OMP PARALLEL PRIVATE (i,j)
-!
-!--          Call salsa processes
-             !$OMP DO
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   CALL salsa_diagnostics( i, j )
-                   CALL salsa_driver( i, j, 3 )
-                   CALL salsa_diagnostics( i, j )
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
-
-             CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
-
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
-!
-!--          Exchange ghost points and decycle if needed.
-             DO  ib = 1, nbins_aerosol
-                CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
-                CALL salsa_boundary_conds( aerosol_number(ib)%conc,            &
-                                           aerosol_number(ib)%init )
-                DO  ic = 1, ncomponents_mass
-                   icc = ( ic - 1 ) * nbins_aerosol + ib
-                   CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
-                   CALL salsa_boundary_conds( aerosol_mass(icc)%conc,          &
-                                              aerosol_mass(icc)%init )
-                ENDDO
-             ENDDO
-
-             IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  ig = 1, ngases_salsa
-                   CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
-                   CALL salsa_boundary_conds( salsa_gas(ig)%conc,              &
-                                              salsa_gas(ig)%init )
-                ENDDO
-             ENDIF
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
-             last_salsa_time = time_since_reference_point
-
-          ENDIF
-
-       ENDIF
-
-    ENDIF
-
 !
 !-- Loop over all prognostic equations
@@ -1153,8 +1089,4 @@
 
     INTEGER(iwp) ::  i     !<
-    INTEGER(iwp) ::  ib    !< index for aerosol size bins (salsa)
-    INTEGER(iwp) ::  ic    !< index for chemical compounds (salsa)
-    INTEGER(iwp) ::  icc   !< additional index for chemical compounds (salsa)
-    INTEGER(iwp) ::  ig    !< index for gaseous compounds (salsa)
     INTEGER(iwp) ::  j     !<
     INTEGER(iwp) ::  k     !<
@@ -1168,61 +1100,10 @@
     ENDIF
 !
-!-- Run SALSA and aerosol dynamic processes. SALSA is run with a longer time 
-!-- step. The exchange of ghost points is required after this update of the 
-!-- concentrations of aerosol number and mass 
-    IF ( salsa )  THEN
-       IF ( time_since_reference_point >= skip_time_do_salsa )  THEN
-          IF ( ( time_since_reference_point - last_salsa_time ) >= dt_salsa )  &
-          THEN
-             CALL cpu_log( log_point_s(90), 'salsa processes ', 'start' )
-             !$OMP PARALLEL PRIVATE (i,j)
-             !$OMP DO
-!
-!--          Call salsa processes
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   CALL salsa_diagnostics( i, j )
-                   CALL salsa_driver( i, j, 3 )
-                   CALL salsa_diagnostics( i, j )
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
-
-             CALL cpu_log( log_point_s(90), 'salsa processes ', 'stop' )
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'start' )
-!
-!--          Exchange ghost points and decycle if needed.
-             DO  ib = 1, nbins_aerosol
-                CALL exchange_horiz( aerosol_number(ib)%conc, nbgp )
-                CALL salsa_boundary_conds( aerosol_number(ib)%conc,            &
-                                           aerosol_number(ib)%init )
-                DO  ic = 1, ncomponents_mass
-                   icc = ( ic - 1 ) * nbins_aerosol + ib
-                   CALL exchange_horiz( aerosol_mass(icc)%conc, nbgp )
-                   CALL salsa_boundary_conds( aerosol_mass(icc)%conc,          &
-                                              aerosol_mass(icc)%init )
-                ENDDO
-             ENDDO
-             IF ( .NOT. salsa_gases_from_chem )  THEN
-                DO  ig = 1, ngases_salsa
-                   CALL exchange_horiz( salsa_gas(ig)%conc, nbgp )
-                   CALL salsa_boundary_conds( salsa_gas(ig)%conc,              &
-                                              salsa_gas(ig)%init )
-                ENDDO
-             ENDIF
-             CALL cpu_log( log_point_s(91), 'salsa exch-horiz ', 'stop' )
-             last_salsa_time = time_since_reference_point
-          ENDIF
-       ENDIF
-    ENDIF
-
-!
 !-- Calculate non advective processes for all other modules
     CALL module_interface_non_advective_processes
 !
 !-- Module Inferface for exchange horiz after non_advective_processes but before
-!-- advection. Therefore, non_advective_processes must not run for ghost points.     
+!-- advection. Therefore, non_advective_processes must not run for ghost points.
     CALL module_interface_exchange_horiz()
-    
 !
 !-- u-velocity component